import os
import sys

sys.path.append(os.path.dirname(sys.path[0]))
from utils.db_util import DBUtil, DbTypes
from utils.ssh_util import SSHUtil
from utils.common_util import CommonUtil


def export_postgresql():
    pass


def export_postgresql_cluster():
    site_name = CommonUtil.get_sys_arg(1, None)
    date_info = CommonUtil.get_sys_arg(2, None)
    tb_type = CommonUtil.get_sys_arg(3, None)

    # 导出detail到集群
    CommonUtil.judge_is_work_hours(
        site_name=site_name,
        date_type="day",
        date_info=date_info,
        principal='hejiangming',
        priority=1,
        export_tools_type=1
    )

    db_type = DbTypes.postgresql_cluster.name
    print(f"导出到{db_type}中")
    #  date_info是日 日期格式 如"2026-03-31"
    d_month_now = CommonUtil.reformat_date(date_info, "%Y-%m-%d", "%Y_%m", )  # 获取年月 2026_03
    rel_date_info = CommonUtil.reformat_date(date_info, "%Y-%m-%d", "%Y-%m", )  # 获取年月 2026-03
    next_month = CommonUtil.get_month_offset(rel_date_info, 1) # 获取下一月
    # 导出表
    export_master_tb = f"{site_name}_{tb_type}_asin_detail"
    export_tb = f"{export_master_tb}_{d_month_now}"
    export_tb_copy = f"{export_tb}_copy" # copy临时表如 us_nsr_asin_detail_2026_04_copy
    # 存在就删除
    sql = f"""drop table if exists {export_tb_copy}"""
    DBUtil.exec_sql(db_type=db_type, site_name=site_name, sql=sql, dispose_flag=True)

    #   按主表结构新建
    sql = f"""create table {export_tb_copy} (  like {export_master_tb} including defaults including constraints );"""
    DBUtil.exec_sql(db_type=db_type, site_name=site_name, sql=sql, dispose_flag=True)

    #  Sqoop 导出需要一段时间，如果直接写正式分区表，导出期间业务查询可能读到一半的脏数据。用 copy 表先接收数据，全部就绪后再一次性切换到正式表，
    # 导出表名 导出到copy表
    sh = CommonUtil.build_export_sh(
        site_name=site_name,
        db_type=db_type,
        hive_tb=f"dwt_{tb_type}_asin_detail",
        export_tb=export_tb_copy,
        col=[
            "asin",
            "title",
            "img_url",
            "ao_val",
            "rating",
            "total_comments",
            "bsr_orders",
            "bsr_orders_change",
            "price",
            "weight",
            "launch_time",
            "date_info",
            "brand_name",
            "buy_box_seller_type",
            "account_name",
            "volume",
            "img_type",
            "last_update_time",
            "asin_type",
            "asin_air_freight_gross_margin",
            "asin_ocean_freight_gross_margin",
            "asin_unlaunch_time",
            "seller_id",
            "seller_country_name",
            "category_first_id",
            "first_category_rank",
            "first_category_rank_date",
            "package_quantity",
            "asin_launch_time_type",
            "seller_country_type",
            "asin_bought_month",
        ],
        partition_dict={
            "site_name": site_name,
            "date_info": rel_date_info
        }
    )

    client = SSHUtil.get_ssh_client()
    SSHUtil.exec_command_async(client, sh, ignore_err=False)
    client.close()

    # 导出表 copy 表替换正式分区
    engine = DBUtil.get_db_engine(db_type, site_name)
    DBUtil.exchange_pg_part_distributed_tb(
        engine=engine,
        source_tb_name=export_tb_copy, # 数据来源：copy 表
        part_master_tb=export_master_tb, # 主表
        part_target_tb=export_tb, # 正式月分区子表
        part_val={ #  part_val = {'from': ['2026-04'], 'to': ['2026-05']},  # 分区范围
            "from": [rel_date_info],
            "to": [next_month]
        },
        drop_old=True
    )
    engine.dispose()
    print("success")


pass

if __name__ == '__main__':
    export_postgresql_cluster()
